<script setup lang="ts">
import { nextTick, ref } from 'vue'
import type { Bills } from '@/types/Bills'
import { useBillsStore } from '@/stores/bills'
import type { VForm } from 'vuetify/components'

const headers = [
  {
    title: 'Id',
    key: 'id'
  },
  {
    title: 'usedUnit',
    key: 'usedUnit'
  },
  {
    title: 'unitToBath',
    key: 'unitToBath'
  },
  {
    title: 'totalPrice',
    key: 'totalPrice'
  },
  {
    title: 'date',
    key: 'date'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const billsStore = useBillsStore()

let editedIndex = -1
const editedBills = ref<Bills>(JSON.parse(JSON.stringify(billsStore.defalutBills)))
const bills = ref<Bills[]>([])
bills.value = billsStore.billsWater
const dialog = ref(false)
const dialogDelete = ref(false)
const form = ref(false)
const loading = ref(false)
const refform = ref<VForm | null>(null)
let lastestId = 1
let latestId = 1
bills.value.forEach((bill) => {
  if (bill.id > lastestId) {
    latestId = bill.id
  }
})
lastestId = latestId + 1

function editItem(item: Bills) {
  editedIndex = bills.value.indexOf(item)
  editedBills.value = Object.assign({}, item)
  dialog.value = true
}

function deleteItem(item: Bills) {
  editedIndex = bills.value.indexOf(item)
  editedBills.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemConfirm() {
  bills.value.splice(editedIndex, 1)
  closeDelete()
}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedBills.value = Object.assign({}, billsStore.defalutBills)
  })
  editedIndex = -1
}

function onSubmit() {}

function closeDialog() {
  dialog.value = false
  nextTick(() => {
    editedBills.value = Object.assign({}, billsStore.defalutBills)
    editedIndex = -1
  })
}

async function save() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(bills.value[editedIndex], editedBills.value)
  } else {
    editedBills.value.id = lastestId++
    bills.value.push(editedBills.value)
  }
  closeDialog()
}
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="bills" height="664">
      <template v-slot:top>
        <v-toolbar flat style="background-color: #282828; color: white">
          <v-toolbar-title>Water Bills</v-toolbar-title>
          <v-dialog v-model="dialog" persistent width="500">
            <template v-slot:activator="{ props }">
              <v-btn v-bind="props" style="background-color: #c7a17a" color="white">
                New Water Bills
              </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Water Bills</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedBills.usedUnit"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Used Unit"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="6">
                        <v-text-field
                          v-model="editedBills.unitToBath"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          clearable
                          label="Price"
                          placeholder="Enter Unit To Bath"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedBills.totalPrice"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Total Price"
                        ></v-text-field>
                      </v-col>

                      <v-col cols="12" sm="12" md="12">
                        <v-text-field
                          v-model="editedBills.date"
                          :readonly="loading"
                          :rules="[(v) => !!v || 'Please fill data']"
                          class="mb-2"
                          clearable
                          label="Date"
                        ></v-text-field>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small style="color: red">*Please fill data</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="primary" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="primary" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>
      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" v-model="dialog" @click="editItem(item)">
          mdi-pencil
        </v-icon>
        <v-icon size="small" v-model="dialogDelete" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>
    </v-data-table>
  </div>

  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>
</template>

<style scoped></style>
